from flask import Flask, render_template, request, flash
from wtforms import Form, StringField
from wtforms.validators import DataRequired, URL
import secrets
import subprocess
import time

DEBUG = False
app = Flask(__name__)
app.config['SECRET_KEY'] = secrets.token_urlsafe(20)


class MyForm(Form):
    url = StringField('url', validators=[DataRequired(), URL(message='Must be a valid URL')])

    @app.route('/', methods=['GET', 'POST'])
    def hello():
        # TODO: error handling?
        form = MyForm(request.form)
        # print(form.errors)

        if request.method == 'POST':
            url = request.form['url']
            print("URL: " + url)

            if form.validate():
                flash('OK. Starting download')
                process = subprocess.Popen(['./dl_wrapper.sh', url],
                                           stdout=subprocess.PIPE,
                                           universal_newlines=True)
                # sleep 2 seconds to catch errors
                time.sleep(2)
                return_code = process.poll()
                if return_code and return_code != 0:
                    # if process return early, there's good chance of an error
                    error_msg = f"An error occurred. return code: {return_code}.\nlogs:\n{process.stdout}"
                    flash(error_msg)

                else:
                    # process is running, probably no error (yet ;-) )
                    flash('OK. Download in progress. File will appear in output dir')

            else:
                flash('Error: bad URL')

        return render_template('index.html', form=form)


if __name__ == "__main__":
    app.run(host='0.0.0.0')
